; pro error_auto
;
;	This procedure computes the error 

FUNCTION STDDEV, X, Double = Double, NaN = NaN

  ON_ERROR, 2

  RETURN, sqrt((moment( X, Double=Double, Maxmoment=2, NaN = NaN ))[1])
END

close,1
istart=16
prob=0.954
ntir=2000
ncomp=452
repertoire = 'ab_spec'
repertoire2 = 'Error'
ntime=124

read,'Number of runs ?',ntir
read,'Number of species ?',ncomp
read,'Number of times ?',ntime
ntime=ntime-1

aa=''

comp=strarr(ncomp)
openr,1,'cond_initial.dat'
for i=0,9 do readf,1,aa
for i=0,ncomp-1 do begin
	readf,1,aa,format='(5x,a10)'
comp(i)=aa
endfor
close,1
close,2
tab_lecture=dblarr(ntir+1,ntime)
ligne=dblarr(ntir+1)
for icomp=istart,ncomp-1 do begin
print,icomp,comp(icomp)


filename=repertoire+'/'+strcompress(comp(icomp),/REMOVE_ALL)+'.dat'
openr,1,filename
;readf,1,ligne
readf,1,tab_lecture
close,1

ind=where(tab_lecture(1:ntir,*) ne 0., count)
if count ne 0 then begin

filename2=repertoire2+'/'+strcompress(comp(icomp),/REMOVE_ALL)+'.dat'
openw,2,filename2
tab=dblarr(ntir,ntime)
for itir=0,ntir-1 do tab(itir,*)=tab_lecture(itir+1,*)
tab(*,*)=alog10(tab(*,*))

time=dblarr(ntime)
diftab=dblarr(ntime)
curve=dblarr(5,ntime)
time(*)=alog10(tab_lecture(0,*))

	
na=200
atab=dblarr(na)
atab_mid=dblarr(na-1)
test=dblarr(na-1)
dint=dblarr(na-1,na-1)
dif=intarr(na-1,na-1)
ind_dif0=intarr(na-1,na-1)
ind_dif1=intarr(na-1,na-1)

for itime=0,ntime-1 do begin
	print,itime,time(itime)
	dens_int=intarr(na-1)
	dens=dblarr(na-1)
	amin=min(tab(*,itime))
	amax=max(tab(*,itime))
	if (amin lt amax) and (10^(amin) ne 0.d0) then begin
		print,amin,amax
		if amin eq amax then begin
			amin=amin*0.95
			amax=amax*1.05
		endif
		da=(amax-amin)/(na-1)
		atab(0)=amin
		atab_mid(0)=amin+da/2.d0
		for ia=1,na-1 do atab(ia)=atab(ia-1)+da
		atab_mid(*)=atab(0:na-2)+da/2.d0

		dens_int=histogram(tab(*,itime),nbins=na-1,MAX=amax,MIN=amin)
		dens=float(dens_int)/float(ntir)

		curve(0,itime)=total(tab(*,itime))/n_elements(tab(*,itime))
	
		for i0=0,na-2 do begin
			for i1=0,na-2 do begin
				imin=min([i0,i1])
				imax=max([i0,i1])
				dint(i0,i1)=total(dens(imin:imax))
				dif(i0,i1)=imax-imin
				ind_dif0(i0,i1)=imin
				ind_dif1(i0,i1)=imax
			endfor
		endfor
		
		indprob=where(dint(*,*) ge prob)
		minprob=min(dif(indprob),count)
		imin=ind_dif0(indprob(count))
		imax=ind_dif1(indprob(count))
		curve(1,itime)=atab_mid(imin)
		curve(2,itime)=atab_mid(imax)
		curve(3,itime)=(curve(2,itime)-curve(1,itime))/2.
		curve(4,itime)=stddev(tab(1:ntir-1,itime))	
		printf,2,time(itime),curve(0:4,itime),format='(6(e15.6,2x))'
	endif
endfor

plot,time,curve(0,*),xrange=[time(0),time(ntime-1)],xstyle=1,$
yrange=[min(curve(0:2,*)),max(curve(0:2,*))],ystyle=1,title= comp(icomp),$
xtitle='log(t)',ytitle='log(X)'
oplot,time,curve(1,*)
oplot,time,curve(2,*)
oplot,time,curve(0,*)+curve(3,*),linestyle=4
oplot,time,curve(0,*)-curve(3,*),linestyle=4
oplot,time,curve(0,*)+curve(4,*),linestyle=2
oplot,time,curve(0,*)-curve(4,*),linestyle=2
close,2

endif
endfor ;icomp
end

