; pro species_file
;
; The output files of the models are usually very big. For this reason,
; I create new files for each species which contains the abundance species 
; of all the runs at each time.
; To run this procedure, simply enter "IDL" and then ".r species_file".
; This procedure may take some time depending on the number of runs and 
; species you have.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;; Definition of some parameters ;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; These are the parameters you may have to change
;

ntirage=2000									
nspec=452										
ntime=124										
rep='results'									
rep2='ab_spec'									

read,'Number of runs ?',ntirage

if ntirage gt 4000 then begin
	print,'You have to modify the format to print the abundance files.'
	stop
endif	
read,'Number of species ?',nspec
read,'Number of times ?',ntime
if ntime ne 124 then begin
	print,'You have to modify the format to read the plot.dat files.'
	stop
endif	

read,'Repertory where the plot.dat files are ?',rep
read,'Repertory where the abundance files will be written ?',rep2									
												
aa=' '
n=0.	& n2=n
species=strarr(nspec)
tyr=fltarr(ntime)
ab=fltarr(ntirage,nspec,ntime)
nhtot=fltarr(ntirage)
nn=dblarr(ntime)

;;;;;;;;;;;;;; Openning the output files of the chemical model
; This part has to be modified if you have modified the format of the plot.dat
; files
; 

for i=0,ntirage-1 do begin
	char2=strcompress(rep+'/plot'+string(i)+'.dat', /remove_all)
	
	openr,1,char2
	print,char2

	readf,1,aa
	readf,1,format='(23x,e10.2)',n
	nhtot(i)=n
	readf,1,tyr
	for j=0,nspec-1 do begin
		; MODIFY THE FORMAT HERE IS THE NUMBER OF TIMES IS DIFFERENT
		readf,1,format='(a10,124(d16.8))',aa,nn
		species(j)=strcompress(aa, /remove_all)
		ab(i,j,*)=nn(*)
	endfor
	close,1
endfor			


;;;;;;;;;;;;;;;;;; Writing the abundances for each species in a separate file
;

for i=0,nspec-1 do begin

	char3=strcompress(rep2+'/'+species(i)+'.dat', /remove_all)	
	print,char3
	openw,1,char3
	for k=1,n_elements(tyr)-1 do begin
		n=tyr(k)
		n2=abs(ab(*,i,k))
		; MODIFY THE FORMAT HERE IS THE NUMBER RUNS IS LARGER
		printf,1,format='(e9.2,4000(e10.3))',n,n2		
		endfor
	close,1
endfor			


end		
