c	V. W. 2010
c	This program is used to generate random numbers 
c	following a normal or uniform distribution.
C
C	NR IS THE NUMBER OF REACTIONS
C	NLINE IS THE NUMBER OF LINE IN THE CDDATA FILE TO IGNORE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	PROGRAM RUN_UNC 
	IMPLICIT NONE 
	
	INTEGER NR,I,J,K,L,SD1,NS,ELEMENT,NELEM,ISP,g1,g2,sd2
c	integer random4
	PARAMETER (NR=4479,NS=468,NELEM=14)
	DOUBLE PRECISION RANDOM1(NR),RANDOM2(NR),UNC(NR),U1,U2,PI,
     &	TD,NH,RANDOM3(NS),AB(NS),ABBIS(NS),random4(2)

	CHARACTER*120 AA
	CHARACTER*8 SPEC
	DIMENSION SPEC(NS),ELEMENT(NELEM,NS),g1(ns),g2(2)

	DATA PI/ 3.1415926535898/

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	OPENNING THE FILES:
C	CDDATA IS THE RATE COEFFICIENT FILE CONTAINING THE 
C	UNCERTAINTY FACTORS FOR EACH RATE
C	NUM IS THE FILE WHERE THE SCRITP WRITE THE I NUMBER OF 
C	LOOP
C	RANDOM.DAT IS THE OUTPUT FILE OF THIS PROGRAM THERE 
C	THE PARAMETERS FOR THE CHEMICAL MODEL ARE WRITTEN

	OPEN (UNIT=1,FILE='osu_03_2008',STATUS='OLD')
	OPEN (UNIT=2,FILE='num',STATUS='OLD')
	OPEN (UNIT=3,FILE='cond_initial_0D_diffus.dat',STATUS='OLD')
	OPEN (UNIT=9,FILE='random.dat',STATUS='UNKNOWN')
	OPEN (UNIT=10,FILE='random_init.dat',STATUS='UNKNOWN')
	
	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	READING THE UNCERTAINTY FACTORS IN THE CDDATA_UNC FILE

	DO I=1,NR
		READ (1,5) UNC(I)
	ENDDO
5	FORMAT (112X,D6.2)		

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 	COMPUTE THE RANDOM NUMBERS

C	READ THE NUM FILE
	READ (2,*) I	
	WRITE (*,*) 'RUN ',I
C	CHANGE THE SEED	
	g2(1)=10100+I*10
	g2(2)=10000100+I*10
C	THIS IS USING G77
C	CALL SRAND (SD1)
	write(*,*) 'g2', g2
c	write(*,*) 'sd2', sd2
c	do j=1,ns
c		g1(j)=sd1+j
c	enddo
c	call random_seed(put=g1)
	call random_seed(put=g2)

	L=0
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C		TEMPERATURE AND DENSITY
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	FOR A CONSTANT DENSITY AND TEMPERATURE, USE THE TWO 
c FOLLOWING LINES

	TD=50.d0
	NH=2.d3

C	FOR A RANDOM DISTRIBUTION OF T AND NH USE THE FOLLOWING 
c LINES
C	THIS PROGRAM IS FOR RANDOM VARIATION OF T AND NH OF 50% 
c AROUND 10 K AND 2.E4
c	TO BE MODIFIED IF YOU WANT OTHER VALUES

c	NH=2.D0*(RAND(0)*1.D4+5.D3)
c	TD=RAND(0)*10.D0+5.D0
	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C		CHEMICAL REACTIONS	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	COMPUTE A RANDOM NUMBER FOR EACH CHEMICAL RATE COEFFICIENT		
C
	DO J=1,NR*2

c		RAND GIVES A UNIFORME RANDOM NUMBER		
c		U1=RAND(0)
c		U2=RAND(0)
		call random_number(harvest=random4)
c		WE TRANSFORM THIS NUMBER TO HAVE A NORMAL DISTRIBUTION			
		IF (L.LT.NR) THEN 
			L=L+1
			RANDOM1(L)=SQRT(-2.D0*LOG(random4(1)))*
     &			COS(2.D0*PI*random4(2))
			IF (ABS(RANDOM1(L)).GE.1.95) L=L-1
		ENDIF
	ENDDO

c	THE OUTPUT RANDOM1 CONTAINS NR NORMALLY DISTRIBUTED VALUES
c OWER THAN 1.95

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	IF YOU WANT TO STUDY THE SENSITIVITY INSTEAD OF COMPUTING 
C	THE ERROR, UNCOMMENT THE FOLLOWING LINES
C
c	DO J=1,NR
c		RANDOM1(J)=1.D0
c		UNC(J)=1.D0
c	ENDDO
C	UNC(I)=2.D0
	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	INITIAL CONDITIONS (WITHOUT ELEMENTAL CONSERVATION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	COMPUTE A RANDOM NUMBER FOR EACH SPECIES
c	CALL RANDOM_NUMBER(harvest=RANDOM3)
	
C	READ INITIAL CONDITION
c	READ (3,*) AA 
c	write (10,*) '   ' 
c       DO I=1,NS 
c         READ (3,1) SPEC(I),(ELEMENT(ISP,I),ISP=1,NELEM),          
c     &              AB(I)                                            
c	 ABBIS(I)=0.5D0*AB(I)+AB(I)*RANDOM3(I)
c	 
c	 WRITE(10,2)  I,SPEC(I),(ELEMENT(ISP,I),ISP=1,NELEM),          
c     &              ABBIS(I)  
c	ENDDO
c	
c 1      FORMAT(5X,A8,1X,14(I3),2X,D14.8) 
c 2      FORMAT(i4,1X,A8,1X,14(I3),2X,D14.8) 



C	THE PARAMETERS ARE WRITTEN IN THE FILE RANDOM.DAT		

	WRITE (9,*) NH
	WRITE (9,*) TD	
	WRITE (9,*) RANDOM1
	WRITE (9,*) UNC
	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	
	END
